# acl-lib.pl
# Library for editing webmin users, passwords and access rights

do '../web-lib.pl';
&init_config();

# list_cds()
# Returns a list of hashes containing cd details
sub list_cds
{
local(%miniserv, $_, @rv);
&get_miniserv_config(\%miniserv);
open(CDSFILE, $miniserv{'cdsfile'});
while(<CDSFILE>) {
	s/\r|\n//g;
	local @cds = split(/:/, $_);
	if (@cds) {
		local(%cds);
		$cds{'id'} = $cds[0];
		$cds{'name'} = $cds[1];
		$cds{'path'} = $cds[2];
		push(@rv, \%cds);
		}
	}
close(CDSFILE);
return @rv;
}

sub get_free_id()
{
local(%miniserv, $_, $lastid);
$lastid = -1;
&get_miniserv_config(\%miniserv);
open(CDSFILE, $miniserv{'cdsfile'});
while(<CDSFILE>) {
	s/\r|\n//g;
	local @cds = split(/:/, $_);
	$lastid++;
	if (@cds[0] ne $lastid){
		close(CDSFILE);
		return $lastid;
	}
}
close(CDSFILE);
$lastid++;
return $lastid;
}

# modify_cdname(id, newname)
sub modify_cdname
{
local(%cds, %miniserv, @cdsfile, $_, $m);
&get_miniserv_config(\%miniserv);

&lock_file($miniserv{'cdsfile'});
open(CDSFILE, $miniserv{'cdsfile'});
@cdsfile = <CDSFILE>;
close(CDSFILE);
open(CDSFILE, "> $miniserv{'cdsfile'}");
foreach (@cdsfile) {
	@splitcds = split(/:/,$_);
	if ($splitcds[0] eq $_[0]){
		print CDSFILE "$_[0]:$_[1]:$splitcds[2]\n";
		}
	else { 
		print CDSFILE $_; }
	}
close(CDSFILE);
&unlock_file($miniserv{'cdsfile'});
}

# delete_cd(id)
# Delete cd from the cds files
sub delete_cd
{
local($_, @cdsfile, %miniserv);
&get_miniserv_config(\%miniserv);
&lock_file($miniserv{'cdsfile'});
open(CDSFILE, $miniserv{'cdsfile'});
@cdsfile = <CDSFILE>;
close(CDSFILE);
open(CDSFILE, "> $miniserv{'cdsfile'}");
foreach (@cdsfile) {
		@cds = split(/:/,$_);
		if ($cds[0] ne $_[0]) { 
			print CDSFILE $_;	
		}
		else {	
			system("rm /isos/$cds[2] -f")
		}
	}
close(CDSFILE);
&unlock_file($miniserv{'cdsfile'});
}

# create_cd(cdname)
sub create_cd
{
local(%cds, %miniserv, @cdsfile, $_, $m, $cdid);
&get_miniserv_config(\%miniserv);

$cdid = get_free_id();

$temp = system("cat /dev/cdrom > /isos/$cdid.iso");
if (!$temp) {
	$temp = system("eject /dev/cdrom");
}
else {
	return 0;
}

&lock_file($miniserv{'cdsfile'});
open(CDSFILE, ">> $miniserv{'cdsfile'}");
	print (CDSFILE "$cdid:$_[0]:$cdid\.iso\n");
close(CDSFILE);
&unlock_file($miniserv{'cdsfile'});
return 1;
}

# get_cdsize()
sub get_cdsize
{
	mkdir "/dev/cdtemp";
	if (!system("mount /dev/cdtemp")) {
		open(GETCDSIZE, "/bin/df -m -l /dev/cdtemp |");
			while(<GETCDSIZE>) {
				s/\r|\n//g;
				print $_;	
			}
		close(GETCDSIZE);	
		return 1;
	}
	else {
		return 0;
	}
}